#!/usr/bin/perl

use strict;

my $cutoff = 2661; # 2661 mappings refer to code page

# add some more words because the jmp instructions change from
# absolute to relative as the table goes on, so we want to make sure
# that the same kind of jump (absolute) is used for the entire usable
# portion of the table
my $total = 4096 + 26*32;
my $num_words = $total / 32;
my $word = 0;

# assumes that the address to be checked is in "addr"

my $chunk_size = 8; # the size of the mov 32 bit immediate and a relative jump

print 'asm (
     "shrl $12, %%eax \t/* convert addr to just the page number */ \n\t
     movl %%eax, %%ebx \n\t
     shrl $5, %%ebx \t/* calculate which word */ \n\t
     andl $31, %%eax \t/* calculate offset within word */ \n\t

     lea (%%ebx, %%ebx, 1), %%ecx \n\t
     lea (%%ecx, %%ebx, 8), %%ecx \n\t
     add $chunk_base_%=, %%ecx \n\t

/*     lea (chunk_base_%=,%%ebx,$8), %%ecx \t *//* rel jump to %%ebx*chunk_size */\n\t 
     jmp *%%ecx \n\t /* rel jump to %%ebx*chunk_size */\n\t 
   chunk_base_%=: \n\t
 ';

for (my $i = 0; $i < $num_words; $i++)
#for (my $i = 0; $i < 2; $i++)
  {
    # output the chunk for this address
    if ($i < int ($cutoff / 32))
     {
        $word = '$0xffffffff';
      }
    elsif ($i < int ($cutoff / 32) + 1)
      {
        $word = sprintf ('$0x%08x', $cutoff % 32);
      }
    else
      {
        $word = '$0x00000000';
      }
    print "
    movl $word", ', %%ebx \n\t
    jmp end_%= \n\t /* absolute jump to the end */ \n\t
    ';
  }

print 'end_%=: \n\t"';
print '
: : "a" (addr) : "%ebx","%ecx"
);
';

print '
asm ("
     bt %%eax, %%ebx \n\t
     setc %%al \n\t
     andl $0xff, %%eax \n\t
"';

# output / input / clobbered regs
print 
'
  :   "=a" (is_codepage)
  :
  :   "%ebx"
);
';
